VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ListThreads"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : ListThreads
' DateTime  : 09/03/2007 23:02
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Contient une liste de threads
'---------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------
'
' Proprits
'   Thread
'   Count
'
' Mthodes
'   RefreshList
'   RefreshItemInfos
'
'---------------------------------------------------------------------------------------

Option Explicit


' Les Processus (de 1  nbProcess)
Private colThreads As Collection

Private clsThread As clsThreads


Private Sub Class_Initialize()
    Set colThreads = New Collection
    Set clsThread = New clsThreads
End Sub

Private Sub Class_Terminate()
    Set colThreads = Nothing
    Set clsThread = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------


' Renvoie un item de la liste
Public Property Get Thread(ByVal Index As Long) As Thread
    Set Thread = colThreads.Item(Index)
End Property


' Le nombre de processus
Public Property Get Count() As Long
    Count = colThreads.Count
End Property


'---------------------------------------------------------------------------------------
' Procedure : RefreshItemInfos
' DateTime  : 09/03/2007 22:36
' Author    : Vb System Library
' Purpose   : Rafraichit toutes les informations d'un item de la liste
' Params    :
'---------------------------------------------------------------------------------------
Public Sub RefreshItemInfos()
    Dim tempThread As Thread
    For Each tempThread In colThreads
        tempThread.RefreshInfos
    Next
End Sub


'---------------------------------------------------------------------------------------
' Procedure : RefreshList
' DateTime  : 30/11/2006 17:19
' Author    : Vb System Library
' Purpose   : Rafraichit la liste des processus
' Params    :   [Optionnel] RefreshItemInfos : Si activ, les informations des processus seront rafraichies
'                                               Sinon elles ne seront PAS rafraichies (PAR DEFAUT)
'               Les parametres suivants dfinissent le filtre de la liste :
'               [Optionnel] ID : ID du thread
'---------------------------------------------------------------------------------------
Public Sub RefreshList(Optional ByVal RefreshItemInfos As Boolean = False, Optional ByVal ID As Long = -1)
    Dim tabThreadID()       As Long
    Dim tempThread          As Thread
    Dim T                   As Long
    Dim Valide              As Boolean
    ' Vide la liste
    
    Set colThreads = Nothing
    Set colThreads = New Collection
    
    ' Dresse la liste des process
    clsThread.ListThreads tabThreadID()
    For T = LBound(tabThreadID) To UBound(tabThreadID)
        ' Cre l'objet processus
        Set tempThread = New Thread
        tempThread.GetThreadByID tabThreadID(T), RefreshItemInfos
        ' Si le processus rpond aux critres
        Valide = True
        If (ID <> -1) And (tempThread.ID <> ID) Then Valide = False
        ' Ajoute le processus
        If Valide = True Then
            colThreads.Add tempThread
        End If
        Set tempThread = Nothing
    Next T
End Sub

