VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ListWindows"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : ListWindows
' DateTime  : 14/12/2006 18:15
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Objet "liste de fenetres"
'---------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------
'
' Proprits
'   Window
'   Count
'
' Mthodes
'   RefreshList
'   RefreshItemInfos
'
'---------------------------------------------------------------------------------------

Option Explicit


' Les fenetres (de 1  nbWindows)
Private colWindows As Collection

Private clsWindow As New clsWindows


Private Sub Class_Initialize()
    Set colWindows = New Collection
End Sub

Private Sub Class_Terminate()
    Set colWindows = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------


' Renvoie un item de la liste
Public Property Get Window(ByVal Index As Long) As Window
    Set Window = colWindows.Item(Index)
End Property


' Le nombre de processus
Public Property Get Count() As Long
    Count = colWindows.Count
End Property


'---------------------------------------------------------------------------------------
' Procedure : RefreshItemInfos
' DateTime  : 09/03/2007 22:36
' Author    : Vb System Library
' Purpose   : Rafraichit toutes les informations d'un item de la liste
' Params    :
'---------------------------------------------------------------------------------------
Public Sub RefreshItemInfos()
    Dim tempWindow As Window
    For Each tempWindow In colWindows
        tempWindow.RefreshInfos
    Next
End Sub


'---------------------------------------------------------------------------------------
' Procedure : RefreshList
' DateTime  : 14/12/2006 18:15
' Author    : Vb System Library
' Purpose   : Rafraichit la liste des fenetres (rafraichit les proprits des fenetres aussi)
' Params    :
'               Les parametres suivants dfinissent le filtre de la liste :
'               [Optionnel] Handle : Handle de la fenetre
'               [Optionnel] Caption : Titre de la fenetre
'               [Optionnel] ParentProcessID : ID du processus parent
'---------------------------------------------------------------------------------------
Public Sub RefreshList(Optional ByVal Handle As Long = -1, Optional ByVal Caption As Variant, Optional ByVal ParentProcessID As Long = -1)
    Dim tabHWnd()           As Long
    Dim tempWindow          As Window
    Dim T                   As Long
    Dim Valide              As Boolean
    ' Vide la liste
    For Each tempWindow In colWindows
        colWindows.Remove 1
    Next
    ' Dresse la liste des fenetres
    clsWindow.ListWindows tabHWnd()
    For T = LBound(tabHWnd) To UBound(tabHWnd)
        ' Cre l'objet fenetre
        Set tempWindow = New Window
        tempWindow.GetWindowByHandle tabHWnd(T), True   ' Rafraichit toutes les infos
        ' Si la fenetre rpond aux critres
        Valide = True
        If (Handle <> -1) And (tempWindow.Handle <> Handle) Then Valide = False
        If (Not IsMissing(Caption)) Then
            If (VarType(Caption) = vbString) And (tempWindow.Caption <> Caption) Then Valide = False
        End If
        If (ParentProcessID <> -1) And (tempWindow.ParentProcessID <> ParentProcessID) Then Valide = False
        ' Ajoute la fenetre
        If Valide = True Then
            colWindows.Add tempWindow
        End If
        Set tempWindow = Nothing
    Next T
End Sub


