VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsOS
' DateTime  : 25/02/2007 18:36
' Author    : Vb System Library
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
' Purpose   : Rcuprer des informations sur le systme d'exploitation
'---------------------------------------------------------------------------------------

Option Explicit


' Liste des versions de Windows
Public Enum WINDOWS_VERSION
    [Windows Vista]
    [Windows Server 2003]
    [Windows XP]
    [Windows 2000]
    [Windows Me]
    [Windows 98]
    [Windows 95]
    [UnKnown]
End Enum


'---------------------------------------------------------------------------------------
' Procedure : GetWindowsVersion
' DateTime  : 25/02/2007 18:40
' Author    : Vb System Library
' Purpose   : Rcupre la version de windows
' Params    : [Optionnel] sWindowsVersion : Renvoie la version sous forme de chaine de caractre
'             [Optionnel] lBuildNumber : Renvoie le numro de Build
'---------------------------------------------------------------------------------------
Public Function GetWindowsVersion(Optional ByRef sWindowsVersion As String, Optional ByRef lBuildNumber As Long) As WINDOWS_VERSION
    Dim OS As OSVERSIONINFO
    'taille de la structure
    OS.dwOSVersionInfoSize = Len(OS)
    'rcupre l'info sur la version
    If GetVersionExA(VarPtr(OS)) = 0 Then
        'chec
        sWindowsVersion = "Cannot retrieve information"
        GetWindowsVersion = UnKnown
        Exit Function
    End If
    'numro de la build
    lBuildNumber = OS.dwBuildNumber
    'rcupre la version en fonction de Major et Minor
    Select Case OS.dwMajorVersion
        Case 6
            GetWindowsVersion = [Windows Vista]
            sWindowsVersion = "Windows Vista"
            Exit Function
        Case 5
            If OS.dwMinorVersion = 2 Then
                GetWindowsVersion = [Windows Server 2003]
                sWindowsVersion = "Windows Server 2003"
            ElseIf OS.dwMinorVersion = 1 Then
                GetWindowsVersion = [Windows XP]
                sWindowsVersion = "Windows XP"
            ElseIf OS.dwMinorVersion = 0 Then
                GetWindowsVersion = [Windows 2000]
                sWindowsVersion = "Windows 2000"
            End If
            Exit Function
        Case 4
            If OS.dwMinorVersion = 90 Then
                GetWindowsVersion = [Windows Me]
                sWindowsVersion = "Windows ME"
            ElseIf OS.dwMinorVersion = 10 Then
                GetWindowsVersion = [Windows 98]
                sWindowsVersion = "Windows 98"
            ElseIf OS.dwMinorVersion = 0 Then
                GetWindowsVersion = [Windows 95]
                sWindowsVersion = "Windows 95"
            End If
            Exit Function
    End Select
    GetWindowsVersion = UnKnown
End Function
